gnutls_certificate_set_x509_simple_pkcs12_mem(3)

NAME
gnutls_certificate_set_x509_simple_pkcs12_mem - API function

SYNOPSIS
#include <gnutls/gnutls.h>

int gnutls_certificate_set_x509_simple_pkcs12_mem(gnutls_certificate_credentials_t res, const gnutls_datum * p12blob, gnutls_x509_crt_fmt_t type, const char * password);

ARGUMENTS

gnutls_certificate_credentials_t res
    is a gnutls_certificate_credentials_t structure.

const gnutls_datum * p12blob
    the PKCS12 blob.

gnutls_x509_crt_fmt_t type
    is PEM or DER of the pkcs12file.

const char * password
    optional password used to decrypt PKCS12 file, bags and keys.

DESCRIPTION
This function sets a certificate/private key pair and/or a CRL in the gnutls_certificate_credentials_t structure. This function may be called more than once (in case multiple keys/certificates exist for the server).

MAC
ed PKCS12 files are supported. Encrypted PKCS12 bags are supported. Encrypted PKCS8 private keys are supported. However, only password based security, and the same password for all operations, are supported. The private keys may be RSA PKCS1 or DSA private keys encoded in the OpenSSL way. PKCS12 file may contain many keys and/or certificates, and there is no way to identify which key/certificate pair you want. You should make sure the PKCS12 file only contain one key/certificate pair and/or one CRL. It is believed that the limitations of this function is acceptable for most usage, and that any more flexibility would introduce complexity that would make it harder to use this functionality at all.

RETURNS
GNUTLS_E_SUCCESS on success, or an error code.

SINCE
2.8.0

REPORTING BUGS
Report bugs to <bug-gnutls@gnu.org>. GnuTLS home page: http://www.gnu.org/software/gnutls/ General help using GNU software: http://www.gnu.org/gethelp/

COPYRIGHT
Copyright © 2008 Free Software Foundation.
Copying and distribution of this file, with or without modification, are permitted in any medium without royalty provided the copyright notice and this notice are preserved.

SEE ALSO
The full documentation for gnutls is maintained as a Texinfo manual. If the info and gnutls programs are properly installed at your site, the command

    info gnutls

should give you access to the complete manual.